=== debian/changelog ===
elastix (4.5-4) unstable; urgency=low

  * Team upload.
  * Build-depend on libtiff-dev, instead of libtiff4-dev.

 -- Dmitrijs Ledkovs <xnox@ubuntu.com>  Thu, 05 Dec 2013 23:10:56 +0000

elastix (4.5-3) unstable; urgency=low

  * debian/control:
     - cme fix dpkg-copyright
     - debhelper 9
     - Build-Depends-Indep: latex-xcolor
       Closes: #713280
     - Remove duplicated "Section: science"
     - Duplicated long description
  * debian/rules: use xz compression
  * debian/copyright:
    s/GNU Lesser Public License/GNU Lesser General Public License/

 -- Andreas Tille <tille@debian.org>  Tue, 25 Jun 2013 08:14:19 +0200

elastix (4.5-2) unstable; urgency=low

  * debian/control:
     - Standards-Version: 3.9.3 (no changes needed)
     - Fixed Vcs fields
     - Build-Depends: s/libpng12-dev/libpng-dev/
       Closes: 662311
  * debian/upstream:
     - Tasks file had a slightly more precise information about author
     - Valid BibTeX authors field
     - More precise information (authors, pmid, doi)
  * debian/copyright: Rewritten to match DEP5. verified using
     cme fix dpkg-copyright
  * Note: Tried debhelper 9 (control+compat) but failed for a reason which
    is totally unclear to me.  There seems to be an error return code in
    the middle of the build process without any visible error message

 -- Andreas Tille <tille@debian.org>  Fri, 11 May 2012 13:50:29 +0200

elastix (4.5-1) unstable; urgency=low

  * New upstream.

 -- Steve M. Robbins <smr@debian.org>  Thu, 13 Oct 2011 01:52:26 -0500
