=== debian/control ===
Source: elastix
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Steve M. Robbins <smr@debian.org>,
           Andreas Tille <tille@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper (>= 9),
               cmake,
               libinsighttoolkit3-dev (>= 3.20.0-5),
               libgdcm2-dev,
               zlib1g-dev,
               libpng-dev,
               libtiff-dev
Build-Depends-Indep: doxygen,
                     graphviz,
                     texlive-latex-base,
                     texlive-latex-extra,
                     texlive-latex-recommended,
                     ghostscript,
                     latex-xcolor
Standards-Version: 3.9.4
Vcs-Browser: http://svn.debian.org/wsvn/debian-med/trunk/packages/elastix/trunk/
Vcs-Svn: svn://svn.debian.org/debian-med/trunk/packages/elastix/trunk/
Homepage: http://elastix.isi.uu.nl/

Package: elastix
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Suggests: elastix-doc
Description: toolbox for rigid and nonrigid registration of images
 Image registration based on the well-known Insight Segmentation and
 Registration Toolkit (ITK). The software consists of a collection of
 algorithms that are commonly used to solve (medical) image
 registration problems. The modular design of elastix allows the user
 to quickly configure, test, and compare different registration
 methods for a specific application. A command-line interface enables
 automated processing of large numbers of data sets, by means of
 scripting.

Package: elastix-doc
Architecture: all
Section: doc
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: toolbox for rigid and nonrigid registration of images - docs
 Image registration based on the well-known Insight Segmentation and
 Registration Toolkit (ITK). The software consists of a collection of
 algorithms that are commonly used to solve (medical) image
 registration problems. The modular design of elastix allows the user
 to quickly configure, test, and compare different registration
 methods for a specific application. A command-line interface enables
 automated processing of large numbers of data sets, by means of
 scripting.
 .
 This package contains the elastix documentation.
