=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --sourcedirectory=src --parallel

binary: binary-arch binary-indep

binary-indep: doc-stamp
	dh $@ --sourcedirectory=src --parallel


# Need -DUSE_KNNGraphAlphaMutualInformationMetric:BOOL=ON, otherwise
# KNN is not built, and link of elastix fails.
#
DEB_CMAKE_EXTRA_FLAGS += \
	-DCMAKE_INSTALL_PREFIX=/usr \
	-DCMAKE_BUILD_TYPE=RELEASE \
	-DCMAKE_SKIP_RPATH=ON \
	-DUSE_KNNGraphAlphaMutualInformationMetric:BOOL=ON

override_dh_auto_configure:
	dh_auto_configure -- $(DEB_CMAKE_EXTRA_FLAGS)

override_dh_builddeb:
	dh_builddeb -- -Z xz

doc: doc-stamp

doc-stamp: help/html/index.html dox/manual/manual.pdf
	touch $@

# build-deps: doxygen, latex, dot
help/html/index.html: help/doxyfile.out
	doxygen $<

dox/manual/manual.pdf: dox/manual/manual.tex
	cd dox/manual && latex manual && latex manual && dvipdf manual
