=== debian/watch ===
version=3
# Author: Daniel Leidert <daniel.leidert@wgdd.de>
opts=downloadurlmangle=s/whatsnew_0(\d+)_(\d+)\.php$/download\/elastix_sources_v$1.$2.tar.bz2/,filenamemangle=s/whatsnew_0(\d+)_(\d+)\.php$/elastix_sources_v$1.$2.tar.bz2/ \
 http://elastix.isi.uu.nl/news.php whatsnew_0(\d+)_(\d+).php

## This works only if the about.php page will be properly maintained
## Author: Paul Wise <pabs@debian.org>
#opts=downloadurlmangle=s/example/sources/ \
#     http://elastix.isi.uu.nl/about.php \
#     .*/elastix_example_v([\d\.]+)\.tar\.bz2
